diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IOccurrenceService.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IOccurrenceService.java
index 65be9d3880..eab15c338c 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IOccurrenceService.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IOccurrenceService.java
@@ -28,14 +28,14 @@ import eu.etaxonomy.cdm.model.common.UuidAndTitleCache;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.cdm.model.description.IndividualsAssociation;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignation;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEvent;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.occurrence.DeterminationEvent;
-import eu.etaxonomy.cdm.model.occurrence.FieldObservation;
+import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
@@ -49,9 +49,9 @@ import eu.etaxonomy.cdm.persistence.query.OrderHint;
  */
 public interface IOccurrenceService extends IIdentifiableEntityService<SpecimenOrObservationBase> {
 
-    public WaterbodyOrCountry getCountryByIso(String iso639);
+    public Country getCountryByIso(String iso639);
 
-    public List<WaterbodyOrCountry> getWaterbodyOrCountryByName(String name);
+    public List<Country> getCountryByName(String name);
 
     /**
      * Returns a paged list of occurrences that have been determined to belong
@@ -136,11 +136,11 @@ public interface IOccurrenceService extends IIdentifiableEntityService<SpecimenO
     @Override
     public Pager<SpecimenOrObservationBase> search(Class<? extends SpecimenOrObservationBase> clazz, String query, Integer pageSize,Integer pageNumber, List<OrderHint> orderHints,List<String> propertyPaths);
 
-    public List<UuidAndTitleCache<FieldObservation>> getFieldObservationUuidAndTitleCache();
+    public List<UuidAndTitleCache<FieldUnit>> getFieldUnitUuidAndTitleCache();
 
-    public List<UuidAndTitleCache<DerivedUnitBase>> getDerivedUnitBaseUuidAndTitleCache();
+    public List<UuidAndTitleCache<DerivedUnit>> getDerivedUnitUuidAndTitleCache();
 
-    public DerivedUnitFacade getDerivedUnitFacade(DerivedUnitBase derivedUnit, List<String> propertyPaths) throws DerivedUnitFacadeNotSupportedException;
+    public DerivedUnitFacade getDerivedUnitFacade(DerivedUnit derivedUnit, List<String> propertyPaths) throws DerivedUnitFacadeNotSupportedException;
 
     public List<DerivedUnitFacade> listDerivedUnitFacades(DescriptionBase description, List<String> propertyPaths);
 
@@ -151,7 +151,7 @@ public interface IOccurrenceService extends IIdentifiableEntityService<SpecimenO
      * ways, all these possible relations are taken into account:
      * <ul>
      * <li>The {@link IndividualsAssociation} elements in a
-     * {@link TaxonDescription} contain {@link DerivedUnitBase}s</li>
+     * {@link TaxonDescription} contain {@link DerivedUnit}s</li>
      * <li>{@link SpecimenTypeDesignation}s may be associated with any
      * {@link HomotypicalGroup} related to the specific {@link Taxon}.</li>
      * <li>A {@link Taxon} may be referenced by the {@link DeterminationEvent}
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IPreferenceService.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IPreferenceService.java
new file mode 100644
index 0000000000..ed50c97ca5
--- /dev/null
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IPreferenceService.java
@@ -0,0 +1,38 @@
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/ 
+package eu.etaxonomy.cdm.api.service;
+
+import eu.etaxonomy.cdm.model.metadata.CdmPreference;
+
+/**
+ * @author a.mueller
+ * @created 2013-09-09
+ */
+public interface IPreferenceService {
+
+	/**
+	 * Retrieve the best matching value for the given preference key.
+	 * @param key
+	 * @return
+	 */
+	public CdmPreference get(CdmPreference.PrefKey key);
+
+	/**
+	 * Write the value for the preference's key
+	 * @param preference
+	 */
+	public void set(CdmPreference preference);
+	
+	/**
+	 * Return the number of all existing cdm preferences
+	 * @return
+	 */
+	public int count();
+
+}
\ No newline at end of file
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IStatisticsService.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IStatisticsService.java
index 52d2eb95a0..c3cc36432f 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IStatisticsService.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IStatisticsService.java
@@ -1,11 +1,24 @@
 package eu.etaxonomy.cdm.api.service;
 
+import java.util.List;
+
 import eu.etaxonomy.cdm.api.service.statistics.Statistics;
 import eu.etaxonomy.cdm.api.service.statistics.StatisticsConfigurator;
+import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 
+/**
+ * @author sybille
+ *
+ */
 public interface IStatisticsService {
 
-	Statistics getCountStatistics(StatisticsConfigurator configurator);
+
+//	List<Statistics> getCountStatistics(StatisticsConfigurator configurator);
+
+	public List<Statistics> getCountStatistics(
+			List<StatisticsConfigurator> configurator);
+
+	public IdentifiableEntity<?> getFilterALL_DB();
 
 	
 }
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/ITaxonService.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/ITaxonService.java
index 3e4b383e5d..4bebdcf806 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/ITaxonService.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/ITaxonService.java
@@ -11,6 +11,7 @@
 package eu.etaxonomy.cdm.api.service;
 
 import java.io.IOException;
+import java.util.EnumSet;
 import java.util.List;
 import java.util.Set;
 import java.util.UUID;
@@ -25,6 +26,7 @@ import eu.etaxonomy.cdm.api.service.exception.DataChangeNoRollbackException;
 import eu.etaxonomy.cdm.api.service.exception.HomotypicalGroupChangeException;
 import eu.etaxonomy.cdm.api.service.exception.ReferencedObjectUndeletableException;
 import eu.etaxonomy.cdm.api.service.pager.Pager;
+import eu.etaxonomy.cdm.api.service.search.LuceneMultiSearchException;
 import eu.etaxonomy.cdm.api.service.search.SearchResult;
 import eu.etaxonomy.cdm.api.service.util.TaxonRelationshipEdge;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
@@ -35,6 +37,8 @@ import eu.etaxonomy.cdm.model.common.RelationshipBase.Direction;
 import eu.etaxonomy.cdm.model.common.UuidAndTitleCache;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
+import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.media.MediaRepresentation;
 import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
@@ -479,22 +483,207 @@ public interface ITaxonService extends IIdentifiableEntityService<TaxonBase>{
     public Pager<IdentifiableEntity> findTaxaAndNames(IFindTaxaAndNamesConfigurator configurator);
 
     /**
+     * performes a union searches for TaxonBase instances on all available
+     * free text indexes. At the time of writing this documentation it combines
+     * {@link #findByDescriptionElementFullText(Class, String, Classification, List, List, boolean, Integer, Integer, List, List)}
+     * and {@link #findByFullText(Class, String, Classification, List, boolean, Integer, Integer, List, List)
+     *
+     * @param queryString
+     *            the query string
+     * @param classification
+     *            Additional filter criterion: If a taxonomic classification
+     *            three is specified here the result set will only contain taxa
+     *            of the given classification
+     * @param languages
+     *            Additional filter criterion: Search only in these languages.
+     *            Not all text fields in the cdm model are multilingual, thus
+     *            this setting will only apply to the multilingiual fields.
+     *            Other fields are searched nevertheless if this parameter is
+     *            set or not.
+     * @param highlightFragments
+     *            TODO
+     * @param pageSize
+     *            The maximum number of objects returned (can be null for all
+     *            objects)
+     * @param pageNumber
+     *            The offset (in pageSize chunks) from the start of the result
+     *            set (0 - based)
+     * @param orderHints
+     *            Supports path like <code>orderHints.propertyNames</code> which
+     *            include *-to-one properties like createdBy.username or
+     *            authorTeam.persistentTitleCache
+     * @param propertyPaths
+     *            properties to initialize - see
+     *            {@link IBeanInitializer#initialize(Object, List)}
+     * @return a paged list of instances of type T matching the queryString and
+     *         the additional filter criteria
+     * @return
+     * @throws CorruptIndexException
+     * @throws IOException
+     * @throws ParseException
+     * @throws LuceneMultiSearchException
+     * @deprecated this search should fully be covered by the new method
+     *      {@link #findTaxaAndNamesByFullText(EnumSet, String, Classification, Set, List, boolean, Integer, Integer, List, List)}
+     *      , maybe we should rename this latter method to give it a more meaningful name
+     */
+    @Deprecated
+    public Pager<SearchResult<TaxonBase>> findByEverythingFullText(String queryString,
+            Classification classification, List<Language> languages, boolean highlightFragments,
+            Integer pageSize, Integer pageNumber, List<OrderHint> orderHints, List<String> propertyPaths) throws CorruptIndexException, IOException, ParseException, LuceneMultiSearchException;
+
+    /**
+     * Searches for TaxonBase instances using the TaxonBase free text index.
+     *
+     * <h4>This is an experimental feature, it may be moved, modified, or even
+     * removed in future releases!!!</h4>
+     *
+     * @param clazz
+     *            Additional filter criterion: The specific TaxonBase subclass
+     *            to search for
+     * @param queryString
+     *            the query string
+     * @param classification
+     *            Additional filter criterion: If a taxonomic classification
+     *            three is specified here the result set will only contain taxa
+     *            of the given classification
+     * @param languages
+     *            Additional filter criterion: Search only in these languages.
+     *            Not all text fields in the cdm model are multilingual, thus
+     *            this setting will only apply to the multilingiual fields.
+     *            Other fields are searched nevertheless if this parameter is
+     *            set or not.
+     * @param highlightFragments
+     *            TODO
+     * @param pageSize
+     *            The maximum number of objects returned (can be null for all
+     *            objects)
+     * @param pageNumber
+     *            The offset (in pageSize chunks) from the start of the result
+     *            set (0 - based)
+     * @param orderHints
+     *            Supports path like <code>orderHints.propertyNames</code> which
+     *            include *-to-one properties like createdBy.username or
+     *            authorTeam.persistentTitleCache
+     * @param propertyPaths
+     *            properties to initialize - see
+     *            {@link IBeanInitializer#initialize(Object, List)}
+     * @return a paged list of instances of type T matching the queryString and
+     *         the additional filter criteria
+     * @throws CorruptIndexException
+     * @throws IOException
+     * @throws ParseException
+     */
+    public Pager<SearchResult<TaxonBase>> findByFullText(Class<? extends TaxonBase> clazz, String queryString, Classification classification,
+            List<Language> languages, boolean highlightFragments, Integer pageSize, Integer pageNumber, List<OrderHint> orderHints,
+            List<String> propertyPaths) throws CorruptIndexException, IOException, ParseException;
+
+
+    /**
+     * @param areaFilter
+     * @param statusFilter
+     * @param classification
+     *            Additional filter criterion: If a taxonomic classification
+     *            three is specified here the result set will only contain taxa
+     *            of the given classification
+     * @param highlightFragments
+     * @param pageSize
+     *            The maximum number of objects returned (can be null for all
+     *            objects)
+     * @param pageNumber
+     *            The offset (in pageSize chunks) from the start of the result
+     *            set (0 - based)
+     * @param orderHints
+     *            Supports path like <code>orderHints.propertyNames</code> which
+     *            include *-to-one properties like createdBy.username or
+     *            authorTeam.persistentTitleCache
+     * @param propertyPath
+     *            Common properties to initialize the instances of the
+     *            CDM types ({@link Taxon} and {@link Synonym}
+     *            this method can return - see {@link IBeanInitializer#initialize(Object, List)}
+     * @return a paged list of instances of {@link Taxon} instances
+     * @throws IOException
+     * @throws ParseException
+     */
+    public Pager<SearchResult<TaxonBase>> findByDistribution(List<NamedArea> areaFilter, List<PresenceAbsenceTermBase<?>> statusFilter,
+            Classification classification,
+            Integer pageSize, Integer pageNumber,
+            List<OrderHint> orderHints, List<String> propertyPaths) throws IOException, ParseException;
+
+    /**
+     * Searches for TaxonBase instances using the TaxonBase free text index.
+     *
+     *
+     *
+     * <h4>This is an experimental feature, it may be moved, modified, or even
+     * removed in future releases!!!</h4>
+     * @param searchModes
+     *            Additional filter criterion: defaults to [doTaxa] if set null
+     * @param queryString
+     *            the query string
+     * @param classification
+     *            Additional filter criterion: If a taxonomic classification
+     *            three is specified here the result set will only contain taxa
+     *            of the given classification
+     * @param namedAreas
+     * @param languages
+     *            Additional filter criterion: Search only in these languages.
+     *            Not all text fields in the cdm model are multilingual, thus
+     *            this setting will only apply to the multilingiual fields.
+     *            Other fields are searched nevertheless if this parameter is
+     *            set or not.
+     * @param highlightFragments
+     *            TODO
+     * @param pageSize
+     *            The maximum number of objects returned (can be null for all
+     *            objects)
+     * @param pageNumber
+     *            The offset (in pageSize chunks) from the start of the result
+     *            set (0 - based)
+     * @param orderHints
+     *            Supports path like <code>orderHints.propertyNames</code> which
+     *            include *-to-one properties like createdBy.username or
+     *            authorTeam.persistentTitleCache
+     * @param propertyPath
+     *            Common properties to initialize the instances of the
+     *            CDM types ({@link Taxon} and {@link Synonym}
+     *            this method can return - see {@link IBeanInitializer#initialize(Object, List)}
+     * @return a paged list of instances of {@link Taxon}, {@link Synonym}, matching the queryString and
+     *         the additional filter criteria
+     * @throws CorruptIndexException
+     * @throws IOException
+     * @throws ParseException
+     * @throws LuceneMultiSearchException
+     */
+    public Pager<SearchResult<TaxonBase>> findTaxaAndNamesByFullText(
+            EnumSet<TaxaAndNamesSearchMode> searchModes,
+            String queryString, Classification classification, Set<NamedArea> namedAreas, Set<PresenceAbsenceTermBase<?>> distributionStatus,
+            List<Language> languages, boolean highlightFragments, Integer pageSize, Integer pageNumber, List<OrderHint> orderHints,
+            List<String> propertyPaths) throws CorruptIndexException, IOException, ParseException, LuceneMultiSearchException;
+
+    /**
+     * Searches for TaxonBase instances by using the DescriptionElement free text index.
+     *
      * <h4>This is an experimental feature, it may be moved, modified, or even
      * removed in future releases!!!</h4>
      *
      * @param clazz
+     *            Additional filter criterion:
      * @param queryString
      *            the query string to filter by
      * @param classification
-     *            If a taxonomic classification three is specified here the
-     *            result set will only contain taxa of the given classification
-     * @param features TODO
+     *            Additional filter criterion: If a taxonomic classification
+     *            three is specified here the result set will only contain taxa
+     *            of the given classification
+     * @param features
+     *            TODO
      * @param languages
-     *            Search only in these languages. Not all text fields in the cdm
-     *            model are multilingual, thus this setting will only apply to
-     *            the multilingiual fields. Other fields are searched
-     *            nevertheless if this parameter is set or not.
-     * @param highlightFragments TODO
+     *            Additional filter criterion: Search only in these languages.
+     *            Not all text fields in the cdm model are multilingual, thus
+     *            this setting will only apply to the multilingiual fields.
+     *            Other fields are searched nevertheless if this parameter is
+     *            set or not.
+     * @param highlightFragments
+     *            TODO
      * @param pageSize
      *            The maximum number of objects returned (can be null for all
      *            objects)
@@ -508,7 +697,8 @@ public interface ITaxonService extends IIdentifiableEntityService<TaxonBase>{
      * @param propertyPaths
      *            properties to initialize - see
      *            {@link IBeanInitializer#initialize(Object, List)}
-     * @return a paged list of instances of type T matching the queryString
+     * @return a paged list of instances of type T matching the queryString and
+     *         the additional filter criteria
      * @throws IOException
      * @throws CorruptIndexException
      * @throws ParseException
@@ -668,15 +858,6 @@ public interface ITaxonService extends IIdentifiableEntityService<TaxonBase>{
      */
     public List<Synonym>  createAllInferredSynonyms(Taxon taxon, Classification tree, boolean doWithMisappliedNames);
 
-    public Pager<SearchResult<TaxonBase>> findByFullText(Class<? extends TaxonBase> clazz, String queryString, Classification classification,
-            List<Language> languages, boolean highlightFragments, Integer pageSize, Integer pageNumber, List<OrderHint> orderHints,
-            List<String> propertyPaths) throws CorruptIndexException, IOException, ParseException;
-
-    public Pager<SearchResult<TaxonBase>> findByEverythingFullText(String queryString,
-            Classification classification, List<Language> languages, boolean highlightFragments,
-            Integer pageSize, Integer pageNumber, List<OrderHint> orderHints, List<String> propertyPaths) throws CorruptIndexException, IOException, ParseException;
-
-
 
 
 }
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IVocabularyService.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IVocabularyService.java
index 086ccd3927..a28980b643 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IVocabularyService.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IVocabularyService.java
@@ -14,6 +14,7 @@ import java.util.List;
 import eu.etaxonomy.cdm.api.service.pager.Pager;
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.common.VocabularyEnum;
 import eu.etaxonomy.cdm.persistence.query.OrderHint;
@@ -82,5 +83,13 @@ public interface IVocabularyService extends IIdentifiableEntityService<TermVocab
 	 */
 	//TODO candidate for harmonization: rename to getTerms(...
 	public Pager<DefinedTermBase> getTerms(TermVocabulary vocabulary, Integer limit, Integer start, List<OrderHint> orderHints, List<String> propertyPaths);
+	
+	/**
+	 * Returns a list of term vocabularies corresponding to a term type
+	 *
+	 * @param termType The term type for which the list of vocabularies is desired
+	 * @return a list of vocabularies
+	 */
+	public <T extends DefinedTermBase> List<TermVocabulary<T>> findByTermType(TermType termType);
 
 }
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IdentificationKeyServiceImpl.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IdentificationKeyServiceImpl.java
index fc1b9cb9a4..b141ee912c 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IdentificationKeyServiceImpl.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IdentificationKeyServiceImpl.java
@@ -5,7 +5,6 @@ import java.util.List;
 
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.stereotype.Service;
-import org.springframework.transaction.annotation.Propagation;
 import org.springframework.transaction.annotation.Transactional;
 
 import eu.etaxonomy.cdm.api.service.pager.Pager;
@@ -27,6 +26,7 @@ public class IdentificationKeyServiceImpl implements IIdentificationKeyService {
         this.dao = dao;
     }
 
+    @Override
     public Pager<IIdentificationKey> page(Integer pageSize, Integer pageNumber,	List<String> propertyPaths) {
         Integer numberOfResults = dao.count();
         List<IIdentificationKey> results = new ArrayList<IIdentificationKey>();
@@ -39,16 +39,17 @@ public class IdentificationKeyServiceImpl implements IIdentificationKeyService {
     }
 
 
+    @Override
     public <T extends IIdentificationKey> Pager<T> findKeysConvering(TaxonBase taxon,
             Class<T> type, Integer pageSize,
             Integer pageNumber, List<String> propertyPaths) {
 
-        Integer numberOfResults = dao.countByTaxonomicScope(taxon, type).intValue();
+        Long numberOfResults = dao.countByTaxonomicScope(taxon, type);
         List<T> results = new ArrayList<T>();
         if(AbstractPagerImpl.hasResultsInRange(numberOfResults, pageNumber, pageSize)){
             results = dao.findByTaxonomicScope(taxon, type, pageSize, pageNumber, propertyPaths);
         }
-        return new DefaultPagerImpl<T>(pageNumber, numberOfResults, pageSize, results);
+        return new DefaultPagerImpl<T>(pageNumber, numberOfResults.intValue(), pageSize, results);
     }
 
 }
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/LocationServiceImpl.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/LocationServiceImpl.java
index 6668a9cb15..7f57f5ae5f 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/LocationServiceImpl.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/LocationServiceImpl.java
@@ -103,7 +103,8 @@ public class LocationServiceImpl extends ServiceBase<DefinedTermBase,IDefinedTer
     public List<NamedAreaVocabularyType> getNamedAreaVocabularyTypes() {
         List<NamedAreaVocabularyType> result = new ArrayList<NamedAreaVocabularyType>(3);
         result.add(NamedAreaVocabularyType.TDWG_AREA);
-        result.add(NamedAreaVocabularyType.WATERBODY_OR_COUNTRY);
+        result.add(NamedAreaVocabularyType.COUNTRY);
+        result.add(NamedAreaVocabularyType.WATERBODY);
         result.add(NamedAreaVocabularyType.CONTINENT);
         return result;
     }
@@ -121,10 +122,12 @@ public class LocationServiceImpl extends ServiceBase<DefinedTermBase,IDefinedTer
         if(vocabularyType == NamedAreaVocabularyType.CONTINENT){
             namedAreaVocabularyUuid = UUID.fromString("e72cbcb6-58f8-4201-9774-15d0c6abc128");
         }
-        if(vocabularyType == NamedAreaVocabularyType.WATERBODY_OR_COUNTRY){
+        if(vocabularyType == NamedAreaVocabularyType.COUNTRY){
             namedAreaVocabularyUuid = UUID.fromString("006b1870-7347-4624-990f-e5ed78484a1a");
         }
-
+        if(vocabularyType == NamedAreaVocabularyType.WATERBODY){
+            namedAreaVocabularyUuid = UUID.fromString("35a62b25-f541-4f12-a7c7-17d90dec3e03");
+        }
         return (OrderedTermVocabulary)orderedVocabularyDao.findByUuid(namedAreaVocabularyUuid);
     }
 
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/MicroFormatCategoricalDescriptionBuilder.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/MicroFormatCategoricalDescriptionBuilder.java
index 917c8527fa..0b6c2831c8 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/MicroFormatCategoricalDescriptionBuilder.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/MicroFormatCategoricalDescriptionBuilder.java
@@ -6,9 +6,9 @@ import java.util.Set;
 
 import org.apache.commons.lang.StringUtils;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.description.Feature;
-import eu.etaxonomy.cdm.model.description.Modifier;
 import eu.etaxonomy.cdm.model.description.State;
 import eu.etaxonomy.cdm.model.description.StateData;
 import eu.etaxonomy.cdm.model.description.TextData;
@@ -24,9 +24,9 @@ public class MicroFormatCategoricalDescriptionBuilder extends AbstractCategorica
 		for (Iterator<StateData> sd = states.iterator() ; sd.hasNext() ;){
 			StateData stateData = sd.next();
 			State s = stateData.getState();
-			Set<Modifier> modifiers = stateData.getModifiers(); // the states and their according modifiers are simply written one after the other
-			for (Iterator<Modifier> mod = modifiers.iterator() ; mod.hasNext() ;){
-				Modifier modifier = mod.next();
+			Set<DefinedTerm> modifiers = stateData.getModifiers(); // the states and their according modifiers are simply written one after the other
+			for (Iterator<DefinedTerm> mod = modifiers.iterator() ; mod.hasNext() ;){
+				DefinedTerm modifier = mod.next();
 				CategoricalDescription.append(" " + spanClass("modifier") + modifier.getPreferredRepresentation(languages).getLabel() + spanEnd);
 			}
 			CategoricalDescription.append(" " + spanClass("state") + s.getPreferredRepresentation(languages).getLabel() + spanEnd);
